<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `src/torch_modules/analysis/gpu_memory.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>gpu_memory.rs - source</title><link rel="stylesheet" type="text/css" href="../../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../../light.css"  id="themeStyle"><link rel="stylesheet" type="text/css" href="../../../../dark.css" disabled ><link rel="stylesheet" type="text/css" href="../../../../ayu.css" disabled ><script id="default-settings"></script><script src="../../../../storage.js"></script><noscript><link rel="stylesheet" href="../../../../noscript.css"></noscript><link rel="icon" type="image/svg+xml" href="../../../../favicon.svg">
<link rel="alternate icon" type="image/png" href="../../../../favicon-16x16.png">
<link rel="alternate icon" type="image/png" href="../../../../favicon-32x32.png"><style type="text/css">#crate-search{background-image:url("../../../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 8]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu">&#9776;</div><a href='../../../../HPGO/index.html'><div class='logo-container rust-logo'><img src='../../../../rust-logo.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!" aria-haspopup="menu"><img src="../../../../brush.svg" width="18" alt="Pick another theme!"></button><div id="theme-choices" role="menu"></div></div><script src="../../../../theme.js"></script><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><button type="button" class="help-button">?</button>
                <a id="settings-menu" href="../../../../settings.html"><img src="../../../../wheel.svg" width="18" alt="Change settings"></a></div></form></nav><section id="main" class="content"><pre class="line-numbers"><span id="1"> 1</span>
<span id="2"> 2</span>
<span id="3"> 3</span>
<span id="4"> 4</span>
<span id="5"> 5</span>
<span id="6"> 6</span>
<span id="7"> 7</span>
<span id="8"> 8</span>
<span id="9"> 9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
</pre><div class="example-wrap"><pre class="rust ">
<span class="kw">use</span> <span class="kw">crate</span>::<span class="ident">environment</span>::<span class="kw-2">*</span>;
<span class="kw">use</span> <span class="kw">crate</span>::<span class="ident">torch_modules</span>::<span class="ident">model</span>::<span class="kw-2">*</span>;

<span class="kw">use</span> <span class="ident">rayon</span>::<span class="ident">prelude</span>::<span class="kw-2">*</span>;

<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">max_single_gpu_batch_size</span>(<span class="ident">m</span>: <span class="kw-2">&amp;</span><span class="ident">model</span>::<span class="ident">Model</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">u32</span> {
    <span class="comment">// assume m is already under GBS</span>
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">param_size</span>: <span class="ident">f64</span> <span class="op">=</span> <span class="ident">m</span>.<span class="ident">layers</span>.<span class="ident">par_iter</span>().<span class="ident">map</span>(<span class="op">|</span><span class="ident">s</span><span class="op">|</span> <span class="ident">s</span>.<span class="ident">parameter_size</span>).<span class="ident">sum</span>();
    <span class="ident">param_size</span> <span class="kw-2">*</span><span class="op">=</span> <span class="ident">m</span>.<span class="ident">optimizer_memory_scaling</span> <span class="kw">as</span> <span class="ident">f64</span>;
    <span class="kw">let</span> <span class="ident">activation_size</span>: <span class="ident">f64</span> <span class="op">=</span> <span class="ident">m</span>.<span class="ident">layers</span>.<span class="ident">par_iter</span>().<span class="ident">map</span>(<span class="op">|</span><span class="ident">s</span><span class="op">|</span> <span class="ident">s</span>.<span class="ident">activation_size</span>).<span class="ident">sum</span>();
    <span class="macro">println</span><span class="macro">!</span>(<span class="string">&quot;Parameter Size: {}&quot;</span>, <span class="ident">param_size</span>);
    <span class="macro">println</span><span class="macro">!</span>(<span class="string">&quot;Activation Size: {}&quot;</span>, <span class="ident">activation_size</span>);
    <span class="macro">println</span><span class="macro">!</span>(<span class="string">&quot;GBS = {}&quot;</span>, <span class="ident">m</span>.<span class="ident">global_batch_size</span>);
    ((<span class="ident">device</span>::<span class="ident">GPU_MEMORY</span> <span class="op">-</span> <span class="ident">param_size</span>) <span class="op">/</span> <span class="ident">m</span>.<span class="ident">peak_activation_per_batch</span>) <span class="kw">as</span> <span class="ident">u32</span>
}
</pre></div>
</section><section id="search" class="content hidden"></section><section class="footer"></section><script>window.rootPath = "../../../../";window.currentCrate = "HPGO";</script><script src="../../../../main.js"></script><script src="../../../../source-script.js"></script><script src="../../../../source-files.js"></script><script defer src="../../../../search-index.js"></script></body></html>